(***********************************************************************)
(*  v      *   The Coq Proof Assistant  /  The Coq Development Team    *)
(* <O___,, *        INRIA-Rocquencourt  &  LRI-CNRS-Orsay              *)
(*   \VV/  *************************************************************)
(*    //   *      This file is distributed under the terms of the      *)
(*         *       GNU Lesser General Public License Version 2.1       *)
(***********************************************************************)

(*i $Id: ocaml.mli,v 1.7 2001/05/14 14:49:58 filliatr Exp $ i*)

(*s Some utility functions to be reused in module [Haskell]. *)

open Pp
open Miniml
open Names

val string : string -> std_ppcmds
val open_par : bool -> std_ppcmds
val close_par : bool -> std_ppcmds

val collect_lambda : ml_ast -> identifier list * ml_ast
val push_vars : identifier list -> identifier list * Idset.t ->
  identifier list * (identifier list * Idset.t)

val current_module : string ref

(*s Production of Ocaml syntax. We export both a functor to be used for 
    extraction in the Coq toplevel and a function to extract some 
    declarations to a file. *)

open Mlutil

module Make : functor(P : Mlpp_param) -> Mlpp

val current_module : string ref
val extract_to_file : string -> extraction_params -> ml_decl list -> unit


